; Form Importing Wizard 0.9
;   by Kamek - ircweb@hotmail.com
; Converts Visual Basic forms (.frm files) to mIRC dialogs
; to use, type '/formwiz [filename]'

alias -l formwiz.ver return 0.9
alias -l formwiz.help return $scriptdir $+ readme.formwiz.html

alias formwiz {
  if ($1 == -u) { formwiz.uninstall | return }
  var %d = formwiz
  if ($dialog(%d)) { dialog -v %d }
  else { dialog -m %d %d | if ($isfile($1-)) { did -o %d 101 1 $1- | formwiz.proceed } }
}
alias -l formwiz.uninstall {
  if (!$input(Are you sure you want to uninstall Form Importing Wizard?, 136, Uninstall Form Importing Wizard)) { return }
  unset %formwiz..* | closewin @formwiz..* | if ($isfile($settings.file)) { .remove $settings.file }
  .timer -o 1 0 .unload -rs $script | echo $colour(info) -qatei2 *** Form Importing Wizard uninstalled
}

dialog formwiz {
  title "Form Importing Wizard"
  size -1 -1 200 123
  icon $scriptdir $+ FormWiz.icl, 0
  option dbu

  tab "", 1, -20 0 0 0
  tab "", 2
  tab "", 3

  icon 10, 3 3 70 100

  text "&Source file:", 100, 78 2 27 7, tab 1
  edit "", 101, 83 10 101 11, autohs, limit 128, tab 1
  button "&...", 102, 186 10 11 11, tab 1

  text "Options", 200, 78 28 18 7, tab 1
  box "", 201, 98 28 98 4, tab 1
  check "Include &comments", 202, 83 36 53 7, tab 1
  check "Use &DBUs", 203, 83 45 35 7, tab 1
  text "&Rounding method:", 204, 92 54 44 7, disable, tab 1
  radio "Simple rounding", 205, 92 63 47 7, disable, group, tab 1
  radio "Round to nearest integer", 206, 92 72 68 7, disable, tab 1
  radio "Round to nearest even number", 207, 92 81 83 7, disable, tab 1
  radio "Round to nearest odd number", 208, 92 90 80 7, disable, tab 1

  text "Converting...", 300, 78 30 30 7, tab 2
  box "", 301, 78 35 118 14, tab 2
  text "", 302, 81 40 112 7, tab 2
  check "", 303, 0 0 0 0, tab 2

  text "Your Form was converted to a mIRC dialog.", 400, 78 20 103 7, tab 3
  text "", 401, 78 29 102 7, tab 3
  button "Show &error log", 402, 78 38 40 10, tab 3

  button "&Test", 410, 87 55 50 10, tab 3
  button "&View code", 411, 137 55 50 10, tab 3
  button "&Copy to clipboard", 412, 87 65 50 10, tab 3
  button "&Save", 413, 137 65 50 10, tab 3
  box "", 414, 78 82 118 4, tab 3

  check "Convert &another form", 500, 78 96 59 7, tab 3

  box "", 2900, -1 104 202 20
  button "A&bout...", 2904, 2 111 40 10
  button "&Help", 2905, 42 111 40 10
  button "Import", 2903, 118 111 40 10, disable, default
  button "Close", 2902, 158 111 40 10, cancel
}
on *:DIALOG:formwiz:init:0:{
  var %fn = $scriptdir $+ FormWiz.png | if ($isfile(%fn)) { did -g $dname 10 %fn }
  did -h $dname 1
  if ($fwset(comments)) { did -c $dname 202 }
  if ($fwset(dbus)) { did -c $dname 203 | did -e $dname 204,205,206,207,208 }
  if (!$isfile($formwiz.help)) { did -b $dname 2905 }
  did -c $dname $calc(204 + $fwset(rounding))
}
on *:DIALOG:formwiz:edit:101:formwiz.validate
on *:DIALOG:formwiz:sclick:102:{
  var %fn = $sfile($fwset(srcdir) $+ *.frm, Choose frame file)
  if ($isfile(%fn)) { fwset srcdir $nofile(%fn) | did -fo $dname 101 1 %fn | did -c $dname 101 1 1 $calc($len(%fn) + 1) } | elseif (%fn != $null) { beep } | else { return }
  formwiz.validate
}
on *:DIALOG:formwiz:sclick:203:did $iif($did($did).state, -e, -b) $dname 204,205,206,207,208
on *:DIALOG:formwiz:sclicK:402:$dialog(formwiz.errlog, formwiz.errlog, -4)
on *:DIALOG:formwiz:sclicK:410:dlg.test @formwiz.dialog
on *:DIALOG:formwiz:sclicK:411:$dialog(formwiz.code, formwiz.code, -4)
on *:DIALOG:formwiz:sclicK:412:dlg.copy
on *:DIALOG:formwiz:sclicK:413:dlg.save $$sfile($fwset(savedir) $+ *.mrc, Save dialog table, &Save)
on *:DIALOG:formwiz:sclick:2902:closewin @formwiz.dialog @formwiz.dids @formwiz.warnings
on *:DIALOG:formwiz:sclick:2903:formwiz.proceed
on *:DIALOG:formwiz:sclick:2904:$dialog(formwiz.about, formwiz.about, -4)
on *:DIALOG:formwiz:sclick:2905:run $formwiz.help
alias -l getchecked var %i = $0 | while (%i > 1) { if ($did($1, $ [ $+ [ %i ] ] ).state) { return $calc(%i - 1) } | dec %i }

alias -l formwiz.validate var %d = formwiz | if (!$dialog(%d)) { return } | did $iif(($isfile($did(%d, 101))), -et, -b) %d 2903
alias -l showtab {
  var %d = formwiz
  did -vf %d $1 | did -h %d 1
  if ($1 = 1) { did -ot %d 2903 1 Import }
  elseif ($1 = 2) { did -ob %d 2903 1 Return }
  elseif ($1 = 3) { did -oe %d 2903 1 &Finish }
}
alias -l dlg.center {
  if ($dialog($1)) && ($dialog($2)) { dialog -s $2 $calc($dialog($1).x + ($dialog($1).w - $dialog($2).w) / 2) $calc($dialog($1).y + ($dialog($1).h - $dialog($2).h) / 2) -1 -1 }
}
alias -l formwiz.proceed {
  var %d = formwiz, %tab = $dialog(%d).tab
  if (%tab = 1) { _fwset comments 202 | _fwset dbus 203 | fwset rounding $getchecked(%d, 205, 206, 207, 208) | settings.save }
  elseif (%tab = 3) && (!$did(%d, 500).state) { dialog -c %d | return }
  %tab = $gettok(2 1 1, %tab, 32) | showtab %tab | if (%tab = 2) { out 2 0 Loading file... | .timer -o 1 0 dlg.load }
}

alias -l showresult {
  var %d = formwiz, %e, %e
  if (!$dialog(%d)) { return }
  if ($line(@formwiz.warnings, 0)) { %e = Some | %e = -v } | else { %e = No | %e = -h }
  did -o %d 401 1 %e errors ocurred during the conversion.
  did %e %d 402
  showtab 3
}
alias -l fwset if ($isid) { return $hget(formwiz.settings, $1) } | hadd formwiz.settings $1-
alias -l _fwset fwset $1 $did($dname, $2).state

dialog formwiz.code {
  title "Generated code"
  size -1 -1 190 150
  icon $scriptdir $+ formwiz.icl, 2
  option dbu

  edit "", 1, 2 2 186 129, multi, hsbar, vsbar, read

  box "", 2900, -1 131 192 20
  button "Close", 2902, 138 138 50 10, default, cancel
}
on *:DIALOG:formwiz.code:init:0:dlg.center formwiz $dname | filter -wo @formwiz.dialog $dname 1 * | did -c $dname 1 1

dialog formwiz.errlog {
  title "Error log"
  size -1 -1 190 100
  icon $scriptdir $+ formwiz.icl, 3
  option dbu

  edit "", 1, 2 2 186 79, multi, vsbar, read

  box "", 2900, -1 81 192 20
  button "Close", 2902, 138 88 50 10, default, cancel
}
on *:DIALOG:formwiz.errlog:init:0:dlg.center formwiz $dname | filter -wo @formwiz.warnings $dname 1 * | did -c $dname 1 1

dialog formwiz.error {
  title "Error"
  size -1 -1 100 36
  option dbu
  icon $mircexe, 16

  icon 1, 2 2 16 16
  text "", 2, 20 2 78 20

  button "OK", 2902, 30 24 40 10, default, ok
}
on *:DIALOG:formwiz.error:init:0:{
  did -g $dname 1 4 $scriptdir $+ formwiz.icl | dlg.center formwiz $dname | did -o $dname 2 1 %formwiz..errmsg | unset %formwiz..errmsg
}

dialog formwiz.about {
  title "About Form Importing Wizard"
  size -1 -1 103 38
  option dbu
  icon $scriptdir $+ formwiz.icl, 0

  text "", 1, 2 2 99 7
  text "Author: Kamek -", 2, 2 12 38 7
  link "ircweb@hotmail.com", 3, 42 12 49 7

  box "", 2900, -1 19 105 20
  button "OK", 2902, 61 26 40 10, default, ok
}
on *:DIALOG:formwiz.about:init:0:{
  dlg.center formwiz $dname
  did -o $dname 1 1 Form Importing Wizard v $+ $formwiz.ver
}




on *:LOAD:echo $colour(info) -atei2 *** To open the Form Importing Wizard, type '/formwiz'.
on *:START:hmake formwiz.settings 10 | settings.load | unset %formwiz..*

alias -l settings.load {
  if ($isfile($settings.file)) { hload -b formwiz.settings $settings.file }
  if ($fwset(comments) = $null) { fwset comments 1 }
  if ($fwset(dbus) = $null) { fwset dbus 0 }
  if ($fwset(rounding) = $null) { fwset rounding 1 }
}
alias -l settings.save hsave -bo formwiz.settings $settings.file
alias -l settings.file return " $+ $scriptdir $+ formwiz.dat"
alias -l load.err out 4 0 An error ocurred. | %formwiz..errmsg = $1- | $dialog(formwiz.error, formwiz.error, -4) | did -et formwiz 2903 | dlg.unload $false | showtab 1
alias -l load.warn aline @formwiz.warnings $1-

alias dlg.load {
  if (!$dialog(formwiz)) { return }
  var %wi = @formwiz.input, %wd = @formwiz.dialog, %wdid = @formwiz.dids, %ww = @formwiz.warnings, %fn = " $+ $did(formwiz, 101) $+ ", %i = 1, %t
  if (!$hget(dlg.load)) { hmake dlg.load 32 }
  window -lh %wi | clear %wi
  mkw %wi @formwiz.dialog @formwiz.dids @formwiz.warnings
  loadbuf %wi %fn
  tokenize 32 $line(%wi, 1)
  if ($1 != VERSION) || ($0 != 2) { load.err Invalid file. | return }
  elseif ($2 != 5.00) { load.err Can't convert forms from version ' $+ $ifmatch $+ '. | return }
  %formwiz..dbu = $fwset(dbus)
  %formwiz..dbur = $fwset(rounding)
  %formwiz..comments = $fwset(comments)
  %t = $line(%wi, 0)
  while (%i <= %t) {
    tokenize 32 $line(%wi, %i)
    if ($1-2 == Begin VB.Form) {
      obj.load %wi %i 1 | obj.done | titlebar %wd %formwiz..name $gettok(%formwiz..cancelbutton %formwiz..okbutton, 1, 32) | dlg.unload | return
    }
    elseif ($1-2 == Begin VB.MDIForm) { load.err MDI Forms aren't supported. | return }
    inc %i
  }
  load.err Invalid file.
  dlg.unload
}
alias -l mkw var %i = $0, %w | while (%i) { %w = $ [ $+ [ %i ] ] | if ($window(%w)) { clear %w } | else { window -lh %w } | dec %i }
alias -l dlg.unload {
  var %i, %w = @formwiz.input | if ($1 != $false) { out 2 0 Done. | .timer -om 1 500 showresult } | else { %w = %w @formwiz.dialog @formwiz.dids @formwiz.warnings }
  unset %formwiz..* | closewin %w
  %i = $window(@formwiz.parent.*, 0) | while (%i) { window -c $window(@formwiz.parent.*, %i) | dec %i }
  if ($hget(dlg.load)) { hfree dlg.load }
}
alias -l closewin var %i = $0 | while (%i) { window -c $ [ $+ [ %i ] ] | dec %i }
alias -l isbin if ($left($1, 5) === BIN $+ $crlf) { return $true } | return $false
alias -l dlgtxt {
  if ($1 == $null) { return "" } | if (" !isin $1) { return " $+ $1 $+ " } | elseif ($ !isin $1) && (% !isin $1) && (, !isin $1) { return $1 } | return " $+ $replace($1, ", '') $+ "
}

menu @formwiz.output {
  Clear out:{
    %i = $window(@formwiz.parent.*, 0) | while (%i) { window -c $window(@formwiz.parent.*, %i) | dec %i }
  }
}

alias -l obj.out {
  var %w = @formwiz.parent. | if ($2) { %w = %w $+ $2 }
  if (!$window(%w)) { window -lh %w }
  if ($obj($1).tabindex isnum) { aline %w $ifmatch $1 }
  else { aline %w -1 $1 }
}

alias -l obj.load {
  var %wi = $1, %i = $2 + 1, %lvl = $3, %nlvl = $3 + 1, %t = $line(%wi, 0), %ln = $line(%wi, $2), %obj.type = $gettok(%ln, 2, 32), %obj.name = $gettok(%ln, 3, 32)
  var %obj.parent = $4
  out 5 $calc(%lvl - 1) Loading object ' $+ %obj.name $+ '
  obj %obj.name <class> %obj.type
  while (%i <= %t) {
    tokenize 32 $line(%wi, %i)
    if ($right($1, 1) == =) && ($2 != =) && ($0 >= 2) { tokenize 32 $left($1, -1) = $2- }
    if ($1 == Begin) { %i = $_obj.load(%wi, %i, %nlvl, %obj.name) }
    elseif ($1 == BeginProperty) { %i = $prop.load(%wi, %i, %nlvl, %obj.name $+ . $+ $2) }
    elseif ($1 == End) {
      $obj.out(%obj.name, %obj.parent)
      return %i
    }
    elseif ($2 == =) && ($0 >= 3) {
      if ($1 == Index) { %obj.name = $index.apply(%obj.name, $3, %obj.type) }
      obj %obj.name $1 $valparse($3-)
    }
    else { load.warn Unknown statement on object ' $+ %obj.name $+ ' (line %i $+ ): $1- | beep }
    inc %i
  }
  aline 4 %wo Object %obj.name $+  is incomplete!
  return %i
}
alias -l _obj.load return $obj.load($1, $2, $3, $4)

alias -l valparse {
  if ("*" iswm $1) { return $replace($mid($left($1, -1), 2), "", ") }
  elseif ("*":???? iswm $1) || ($!"*":???? iswm $1) { return BIN $+ $crlf $+ $1 }
  else { return $gettok($1, 1, 32) }
}

alias -l obj if ($isid) { return $hget(dlg.load, $1 $+ . $+ $prop) } | hadd dlg.load $1 $+ . $+ $2-
alias -l lvl return $gettok($gettok(%formwiz..lvl, $1, 44), $findtok(id name class, $prop, 1, 32), 32)
alias -l obja {
  var %item = $1, %i = 2, %t = $0
  while (%i <= %t) { %item = %item $+ . $+ $ [ $+ [ %i ] ] $+ ( $+ $ [ $+ [ $calc(%i + 1) ] ] $+ ) | inc %i 2 }
  if ($prop) { %item = %item $+ . $+ $prop } | return $hget(dlg.load, %item)
}

alias -l prop.load {
  var %wi = $1, %i = $2 + 1, %lvl = $3, %nlvl = $3 + 1, %t = $line(%wi, 0), %ln = $line(%wi, $2), %prop.name = $gettok(%ln, 2, 32), %obj.name = $4
  hadd dlg.load %obj.name $+ !
  while (%i <= %t) {
    tokenize 32 $line(%wi, %i)
    if ($1 == EndProperty) { return %i }
    elseif ($1 == BeginProperty) { %i = $_prop.load(%wi, %i, %nlvl, %obj.name $+ . $+ $2) }
    elseif ($2 == =) { obj %obj.name $1 $valparse($3-) }
    else { load.warn Unknown statement on object ' $+ %obj.name $+ ' (line %i $+ ): $1- | beep }
    inc %i
  }
  aline 4 %wo Property %prop.name $+  is incomplete!
  return %i
}
alias -l _prop.load return $prop.load($1, $2, $3, $4)

alias -l ccrd {
  var %dbu = $dbu [ $+ [ $replace($prop, x, w, y, h) ] ] , %dbux = $iif(%formwiz..dbu, 1, %dbu), %c = $calc($1 / 30 * %dbux)
  if (. isin %c) {
    var %int = $int(%c)
    if (%formwiz..dbur = 2) { return $round(%c, 0) }
    if (%formwiz..dbur = 3) && (%int & 1) { return $calc(%int + 1) }
    if (%formwiz..dbur = 4) && (%int !& 1) { return $calc(%int + 1) }
    return %int
  }
  return %c
}

alias -l index.apply {
  var %newname = $1 $+ ( $+ $2 $+ ), %m = $1 $+ .*, %i = 1, %t = $hmatch(dlg.load, %m, 0), %item
  while (%i <= %t) { %item = $hmatch(dlg.load, %m, %i) | hadd dlg.load $puttok(%item, %newname, 1, 46) $hget(dlg.load, %item) | inc %i }
  hdel -w dlg.load %m
  return %newname
}



alias -l obj.done {
  var %i, %w, %tw = @formwiz.tmp, %i, %ln
  window -hl %tw
  out 2 0 Reorganizing objects...
  %i = $window(@formwiz.parent.*, 0)
  while (%i) {
    %w = $window(@formwiz.parent.*, %i)
    filter -cww %w %tw -? *
    filter -xcwwtu 1 32 %w %w -? *
    %i = $line(%tw, 0)
    while (%i) { %ln = $line(%tw, %i) | if ($gettok(%ln, 1, 32) = -1) { iline %w 1 %ln } | elseif ($gettok(%ln, 1, 32) = -2) { aline %w %ln } | dec %i }
    dec %i
  }
  window -c %tw
  out 2 0 Building code...
  %formwiz..offx = 0 | %formwiz..offy = 0
  win.build
}

alias -l win.build {
  var %w = @formwiz.parent. $+ $1, %i = 1, %t = $line(%w, 0), %obj, %objt
  while (%i <= %t) {
    %obj = $gettok($line(%w, %i), 2, 32) | %objt = $obj(%obj).<class>
    if ($window(@formwiz.parent. $+ %obj)) { %formwiz..nochildren = $false } | else { %formwiz..nochildren = $true }
    obj.build begin %obj %objt
    if (!%formwiz..nochildren) { _win.build %obj }
    obj.build end %obj %objt
    inc %i
  }
}
alias -l _win.build win.build $1-

alias -l obj.build {
  if ($obj($2).tabindex isnum) { %formwiz..tabindex = $ifmatch } | else { %formwiz..tabindex = -1 }
  if ($1 == begin) && ($isalias(obj.build. $+ $3)) {
    %formwiz..first = $true
    if ($3 == VB.Form) { aline @formwiz.dids $2 $+ . $+ $2 0 }
    else { aline @formwiz.dids %formwiz..name $+ . $+ $2 %formwiz..id }
    %formwiz..lvl = $instok(%formwiz..lvl, %formwiz..id $2-3, -0, 44)
    obj.build. $+ $3 $2- | inc %formwiz..id | inc %formwiz..level | return
  }
  elseif ($1 == end) {
    if ($isalias(obj.build. $+ $3)) {
      %formwiz..lvl = $deltok(%formwiz..lvl, %formwiz..level, 44)
      dec %formwiz..level
      if ($isalias(obj.endbuild. $+ $3)) { obj.endbuild. $+ $3 $2- }
      if (%formwiz..level > 0) { dlgout }
    }
  }
  else { load.warn Class $3 from object ' $+ $2 $+ ' is not supported }
}

alias -l obj.build.VB.Form {
  var %xy | %formwiz..name = $1
  if ($obj($1).startupposition isnum 1-2) { %xy = -1 -1 }
  else { %xy = $ccrd($obj($1).clientleft, twips).x $ccrd($obj($1).clienttop, twips).y }
  dlgout dialog $1 $'{
  dlgout title $dlgtxt($obj($1).caption)
  dlgout size %xy $ccrd($obj($1).clientwidth, twips).x $ccrd($obj($1).clientheight, twips).y
  if (%formwiz..dbu) { dlgout option dbu }
  dlgout
}
alias -l obj.endbuild.VB.Form {
  %formwiz..tabindex = -2
  if (!%formwiz..okbutton) && (!%formwiz..cancelbutton) {
    dlgout ; No OK or Cancel button found; created one
    dlgout button "", %formwiz..id $+ , 0 0 0 0, cancel, hide
    %formwiz..cancelbutton = %formwiz..id
  }
  dlgout $chr(125)
}

alias -l obj.build.VB.Frame {
  var %x = %formwiz..offx + $obj($1).left, %y = %formwiz..offy + $obj($1).top, %f
  if ($obj($1).visible = 0) { %f = $addtok(%f, hide, 44) }
  if ($obj($1).enabled = 0) { %f = $addtok(%f, disable, 44) }
  if ($obj($lvl(-2).name).<tab>) { obj $1 <tab> $ifmatch }
  if ($obj($1).<tab>) { %f = $addtok(%f, tab $ifmatch, 44) }
  if (%f != $null) { %f = , $replace($sorttok(%f, 44), $chr(44), $chr(44) $+ $chr(32)) }
  if ($obj($1).borderstyle = 0) { dlgout ; $1 - Invisible box | dec %formwiz..id }
  else {
    if ($obj($1).height = 60) { var %msg = - Fixed to look like a separator | obj $1 height 120 | obj $1 top $calc($obj($1).top - 60) | %y = %formwiz..offy + $obj($1).top }
    dlgout ; $1 %msg
    dlgout box $dlgtxt($obj($1).caption) $+ , %formwiz..id $+ , $ccrd(%x).x $ccrd(%y).y $ccrd($obj($1).width).x $ccrd($obj($1).height).y $+ %f
  }
  %formwiz..offx = %x
  %formwiz..offy = %y
}
alias -l obj.endbuild.VB.Frame {
  dec %formwiz..offx $obj($1).left
  dec %formwiz..offy $obj($1).top
}

alias -l obj.build.VB.PictureBox {
  var %x = %formwiz..offx + $obj($1).left, %y = %formwiz..offy + $obj($1).top
  dec %formwiz..id
  if ($obj($1).borderstyle != 0) { obj $1 left $calc($obj($1).left + 30) | obj $1 top $calc($obj($1).top + 30) | inc %x 30 | inc %y 30 }
  dlgout ; $1 - PictureBoxes aren't supported in mIRC
  %formwiz..offx = %x
  %formwiz..offy = %y
}
alias -l obj.endbuild.VB.PictureBox {
  dec %formwiz..offx $obj($1).left
  dec %formwiz..offy $obj($1).top
}

alias -l obj.build.VB.CommandButton {
  var %x = %formwiz..offx + $obj($1).left, %y = %formwiz..offy + $obj($1).top, %f
  if ($obj($1).visible = 0) { %f = $addtok(%f, hide, 44) }
  if ($obj($1).enabled = 0) { %f = $addtok(%f, disable, 44) }
  if ($obj($1).default) { %f = $addtok($addtok(%f, default, 44), ok, 44) | %formwiz..okbutton = %formwiz..id }
  if ($obj($1).cancel) { %f = $addtok(%f, cancel, 44) | %formwiz..cancelbutton = %formwiz..id }
  if ($obj($lvl(-2).name).<tab>) { obj $1 <tab> $ifmatch }
  if ($obj($1).<tab>) { %f = $addtok(%f, tab $ifmatch, 44) }
  if (%f != $null) { %f = , $replace($sorttok(%f, 44), $chr(44), $chr(44) $+ $chr(32)) }
  dlgout ; $1
  dlgout button $dlgtxt($obj($1).caption) $+ , %formwiz..id $+ , $ccrd(%x).x $ccrd(%y).y $ccrd($obj($1).width).x $ccrd($obj($1).height).y $+ %f
}

alias -l obj.build.VB.TextBox {
  var %x = %formwiz..offx + $obj($1).left, %y = %formwiz..offy + $obj($1).top, %f = autohs, %p, %txt = $obj($1).text, %msg
  if ($obj($1).visible = 0) { %f = $addtok(%f, hide, 44) }
  if ($obj($1).enabled = 0) { %f = $addtok(%f, disable, 44) }
  if ($obj($1).alignment) { %f = $addtok(%f, $gettok(right center, $ifmatch, 32), 44) }
  if ($obj($1).multiline) { %f = $addtok($addtok(%f, multi, 44), return, 44) }
  if ($obj($1).passwordchar != $null) { if ($ifmatch != *) { %msg = %msg - Custom password character is not supported } | %f = $addtok(%f, pass, 44) }
  if ($obj($1).locked) { %f = $addtok(%f, read, 44) }
  if ($obj($1).scrollbars) {
    %p = $ifmatch
    if (%p & 1) { %f = $addtok(%f, hsbar, 44) }
    if (%p & 2) { %f = $addtok(%f, vsbar, 44) }
  }
  if ($obj($1).maxlength) { %f = $addtok(%f, limit $ifmatch, 44) }
  if ($obj($lvl(-2).name).<tab>) { obj $1 <tab> $ifmatch }
  if ($obj($1).<tab>) { %f = $addtok(%f, tab $ifmatch, 44) }
  if (%f != $null) { %f = , $replace($sorttok(%f, 44), $chr(44), $chr(44) $+ $chr(32)) }
  if ($isbin(%txt)) { %msg = %msg - Can't retrieve text from multiline TextBoxes | var %txt }
  dlgout ; $1 %msg
  dlgout edit $dlgtxt(%txt) $+ , %formwiz..id $+ , $ccrd(%x).x $ccrd(%y).y $ccrd($obj($1).width).x $ccrd($obj($1).height).y $+ %f
}

alias -l obj.build.VB.Label {
  var %x = %formwiz..offx + $obj($1).left, %y = %formwiz..offy + $obj($1).top, %f, %txt, %msg
  if ($obj($1).visible = 0) { %f = $addtok(%f, hide, 44) }
  if ($obj($1).enabled = 0) { %f = $addtok(%f, disable, 44) }
  if ($obj($1).alignment) { %f = $addtok(%f, $gettok(right center, $ifmatch, 32), 44) }
  if ($obj($lvl(-2).name).<tab>) { obj $1 <tab> $ifmatch }
  if ($obj($1).<tab>) { %f = $addtok(%f, tab $ifmatch, 44) }
  if ($obj($1).usemnemonic = 0) { obj $1 caption $replace($obj($1).caption, &, &&) }
  if (%f != $null) { %f = , $replace($sorttok(%f, 44), $chr(44), $chr(44) $+ $chr(32)) }
  set -n %txt $obj($1).caption
  if ($isbin(%txt)) { %msg = %msg - Can't retrieve the caption from multiline Labels | var %txt }
  dlgout ; $1 %msg
  dlgout text $dlgtxt(%txt) $+ , %formwiz..id $+ , $ccrd(%x).x $ccrd(%y).y $ccrd($obj($1).width).x $ccrd($obj($1).height).y $+ %f
}

alias -l obj.build.VB.CheckBox {
  var %x = %formwiz..offx + $obj($1).left, %y = %formwiz..offy + $obj($1).top, %f, %msg
  if ($obj($1).visible = 0) { %f = $addtok(%f, hide, 44) }
  if ($obj($1).enabled = 0) { %f = $addtok(%f, disable, 44) }
  if ($obj($1).alignment) { %f = $addtok(%f, left, 44) }
  if ($obj($1).style) { %f = $addtok(%f, push, 44) }
  if ($obj($1).value) {
    if ($ifmatch = 2) { %f = $addtok(%f, 3state, 44) }
    %msg = %msg - A checkbox can't be checked by default on a table
  }
  if ($obj($lvl(-2).name).<tab>) { obj $1 <tab> $ifmatch }
  if ($obj($1).<tab>) { %f = $addtok(%f, tab $ifmatch, 44) }
  if (%f != $null) { %f = , $replace($sorttok(%f, 44), $chr(44), $chr(44) $+ $chr(32)) }
  dlgout ; $1 %msg
  dlgout check $dlgtxt($obj($1).caption) $+ , %formwiz..id $+ , $ccrd(%x).x $ccrd(%y).y $ccrd($obj($1).width).x $ccrd($obj($1).height).y $+ %f
}

alias -l obj.build.VB.OptionButton {
  var %x = %formwiz..offx + $obj($1).left, %y = %formwiz..offy + $obj($1).top, %f, %msg
  if ($obj($1).visible = 0) { %f = $addtok(%f, hide, 44) }
  if ($obj($1).enabled = 0) { %f = $addtok(%f, disable, 44) }
  if ($obj($1).alignment) { %f = $addtok(%f, left, 44) }
  if ($obj($1).style) { %f = $addtok(%f, push, 44) }
  if ($lvl(-2).name != %formwiz..lastgroup) { %formwiz..lastgroup = $ifmatch | %f = $addtok(%f, group, 44) }
  if ($obj($1).value) { %msg = %msg - A radio button can't be checked by default on a table }
  if ($obj($lvl(-2).name).<tab>) { obj $1 <tab> $ifmatch }
  if ($obj($1).<tab>) { %f = $addtok(%f, tab $ifmatch, 44) }
  if (%f != $null) { %f = , $replace($sorttok(%f, 44), $chr(44), $chr(44) $+ $chr(32)) }
  dlgout ; $1 %msg
  dlgout radio $dlgtxt($obj($1).caption) $+ , %formwiz..id $+ , $ccrd(%x).x $ccrd(%y).y $ccrd($obj($1).width).x $ccrd($obj($1).height).y $+ %f
}

alias -l obj.build.VB.FileListBox buildfakelistbox $1-2 FileListBox
alias -l obj.build.VB.DirListBox buildfakelistbox $1-2 FileListBox
alias -l buildfakelistbox {
  var %x = %formwiz..offx + $obj($1).left, %y = %formwiz..offy + $obj($1).top, %f = $addtok(sort, size, 44)
  var %msg = - $3 $+ es aren't supported by mIRC; converted to ListBox
  if ($obj($1).visible = 0) { %f = $addtok(%f, hide, 44) }
  if ($obj($1).enabled = 0) { %f = $addtok(%f, disable, 44) }
  if ($obj($1).multiselect) {
    if ($ifmatch = 1) { %msg = - Simple MultiSelect is not supported by mIRC; using extended }
    %f = $addtok(%f, extsel, 44)
  }
  if ($obj($lvl(-2).name).<tab>) { obj $1 <tab> $ifmatch }
  if ($obj($1).<tab>) { %f = $addtok(%f, tab $ifmatch, 44) }
  if (%f != $null) { %f = , $replace($sorttok(%f, 44), $chr(44), $chr(44) $+ $chr(32)) }
  dlgout ; $1 %msg
  dlgout list %formwiz..id $+ , $ccrd(%x).x $ccrd(%y).y $ccrd($obj($1).width).x $ccrd($obj($1).height).y $+ %f
}

alias -l obj.build.VB.DriveListBox {
  var %x = %formwiz..offx + $obj($1).left, %y = %formwiz..offy + $obj($1).top, %f = drop, %msg = DriveListBoxes aren't supported by mIRC; converted to ComboBox
  if ($obj($1).visible = 0) { %f = $addtok(%f, hide, 44) }
  if ($obj($1).enabled = 0) { %f = $addtok(%f, disable, 44) }
  ; drop-down...
  %msg = - The height of drop-down combos is undefined in VB; it will be set to the same as width
  obj $1 height $obj($1).width
  ;
  if ($obj($lvl(-2).name).<tab>) { obj $1 <tab> $ifmatch }
  if ($obj($1).<tab>) { %f = $addtok(%f, tab $ifmatch, 44) }
  if (%f != $null) { %f = , $replace($sorttok(%f, 44), $chr(44), $chr(44) $+ $chr(32)) }
  dlgout ; $1 %msg
  dlgout combo %formwiz..id $+ , $ccrd(%x).x $ccrd(%y).y $ccrd($obj($1).width).x $ccrd($obj($1).height).y $+ %f
}

alias -l obj.build.VB.ListBox {
  var %x = %formwiz..offx + $obj($1).left, %y = %formwiz..offy + $obj($1).top, %f, %msg
  if ($obj($1).visible = 0) { %f = $addtok(%f, hide, 44) }
  if ($obj($1).enabled = 0) { %f = $addtok(%f, disable, 44) }
  if ($obj($1).multiselect) {
    if ($ifmatch = 1) { %msg = - Simple MultiSelect is not supported by mIRC; using extended }
    %f = $addtok(%f, extsel, 44)
  }
  if ($obj($1).sorted) { %f = $addtok(%f, sort, 44) }
  if ($obj($1).integralheight) { %f = $addtok(%f, size, 44) }
  if ($obj($1).style) { %msg = %msg - Checkbox style is not supported by mIRC }
  if ($obj($1).list) { %msg = %msg - Can't read the initial list items }
  if ($obj($1).columns > 0) { %msg = %msg - Multiple columns aren't supported by mIRC }
  if ($obj($lvl(-2).name).<tab>) { obj $1 <tab> $ifmatch }
  if ($obj($1).<tab>) { %f = $addtok(%f, tab $ifmatch, 44) }
  if (%f != $null) { %f = , $replace($sorttok(%f, 44), $chr(44), $chr(44) $+ $chr(32)) }
  dlgout ; $1 %msg
  dlgout list %formwiz..id $+ , $ccrd(%x).x $ccrd(%y).y $ccrd($obj($1).width).x $ccrd($obj($1).height).y $+ %f
}

alias -l obj.build.VB.ComboBox {
  var %x = %formwiz..offx + $obj($1).left, %y = %formwiz..offy + $obj($1).top, %f, %msg
  if ($obj($1).visible = 0) { %f = $addtok(%f, hide, 44) }
  if ($obj($1).enabled = 0) { %f = $addtok(%f, disable, 44) }
  if ($obj($1).style != 1) {
    %msg = - The height of drop-down combos is undefined in VB; it will be set to the same as width
    obj $1 height $obj($1).width
    %f = $addtok(%f, drop, 44)
    if (!$obj($1).style) { %f = $addtok(%f, edit, 44) }
  }
  if ($obj($1).sorted) { %f = $addtok(%f, sort, 44) }
  if ($obj($1).integralheight) { %f = $addtok(%f, size, 44) }
  if ($obj($1).list) { %msg = %msg - Can't read the default list items }
  if ($obj($lvl(-2).name).<tab>) { obj $1 <tab> $ifmatch }
  if ($obj($1).<tab>) { %f = $addtok(%f, tab $ifmatch, 44) }
  if (%f != $null) { %f = , $replace($sorttok(%f, 44), $chr(44), $chr(44) $+ $chr(32)) }
  dlgout ; $1 %msg
  dlgout combo %formwiz..id $+ , $ccrd(%x).x $ccrd(%y).y $ccrd($obj($1).width).x $ccrd($obj($1).height).y $+ %f
}

alias -l obj.build.VB.HScrollBar buildscrollbar $1-2 $true
alias -l obj.build.VB.VScrollBar buildscrollbar $1-2 $false
alias -l buildscrollbar {
  var %x = %formwiz..offx + $obj($1).left, %y = %formwiz..offy + $obj($1).top, %f, %msg = - mIRC's scroll controls aren't as flexible as VB's ones
  if ($obj($1).max = $null) { obj $1 max 32767 }
  if ($obj($1).min > 0) { %msg = %msg - minimum bound in mIRC must be 0 }
  %f = range $calc($obj($1).max - $obj($1).min)
  if ($3) { %f = $addtok(%f, horizontal, 44) }
  if ($obj($1).visible = 0) { %f = $addtok(%f, hide, 44) }
  if ($obj($1).enabled = 0) { %f = $addtok(%f, disable, 44) }
  if ($obj($lvl(-2).name).<tab>) { obj $1 <tab> $ifmatch }
  if ($obj($1).<tab>) { %f = $addtok(%f, tab $ifmatch, 44) }
  if (%f != $null) { %f = , $replace($sorttok(%f, 44), $chr(44), $chr(44) $+ $chr(32)) }
  dlgout ; $1 %msg
  dlgout scroll "", %formwiz..id $+ , $ccrd(%x).x $ccrd(%y).y $ccrd($obj($1).width).x $ccrd($obj($1).height).y $+ %f
}

alias -l obj.build.VB.Image {
  var %x = %formwiz..offx + $obj($1).left, %y = %formwiz..offy + $obj($1).top, %f, %msg
  if ($obj($1).visible = 0) { %f = $addtok(%f, hide, 44) }
  if ($obj($1).enabled = 0) { %f = $addtok(%f, disable, 44) }
  if (!$obj($1).borderstyle) { %f = $addtok(%f, noborder, 44) }
  else { %msg = %msg - mIRC's border for images is not like the one in Image controls }
  if ($obj($lvl(-2).name).<tab>) { obj $1 <tab> $ifmatch }
  if ($obj($1).<tab>) { %f = $addtok(%f, tab $ifmatch, 44) }
  if (%f != $null) {
    %msg = %msg - mIRC needs a default image to use flags; using its icon
    %f = , $mircexe, 0, $replace($sorttok(%f, 44), $chr(44), $chr(44) $+ $chr(32))
  }
  dlgout ; $1 %msg
  dlgout icon %formwiz..id $+ , $ccrd(%x).x $ccrd(%y).y $ccrd($obj($1).width).x $ccrd($obj($1).height).y $+ %f
}

alias -l obj.build.VB.Menu {
  var %pid, %ditem = menu, %text = $dlgtxt($obj($1).caption), %msg
  if ($lvl(-2).class == VB.Menu) && (($lvl(-2).name != %formwiz..menu.lastparent) || (!%formwiz..nochildren)) {
    %formwiz..menu.lastparent = $ifmatch
    %pid = , $lvl(-2).id
  }
  if (%formwiz..nochildren) { %ditem = item | if ($obj($1).caption == -) { %text = break } }
  if ($obj($1).enabled = 0) || ($obj($1).checked) { %msg = %msg - Menu items can't be checked or disabled by default in mIRC }
  dlgout ; $1 %msg
  dlgout %ditem %text $+ , %formwiz..id $+ %pid
}

alias -l obj.build.MSComctlLib.TabStrip obj.build.ComctlLib.TabStrip $1-
alias -l obj.build.ComctlLib.TabStrip {
  var %xywh = $calc(%formwiz..offx + $ccrd($obj($1).left).x) $calc(%formwiz..offy + $ccrd($obj($1).top).y) $ccrd($obj($1).width).x $ccrd($obj($1).height).y
  var %i = 1, %t = $hmatch(dlg.load, $1 $+ .tabs.*!, 0)
  %formwiz..tabindex = -1
  dlgout ; $1
  while (%i <= %t) {
    $buildcctab(%i, $left($hmatch(dlg.load, $1 $+ .tabs.*!, %i), -1), %xywh)
    inc %i
  }
  dec %formwiz..id
  dlgout
}
alias -l buildcctab {
  if ($1 = 1) { var %pos = , $3 }
  dlgout tab $dlgtxt($obj($2).caption) $+ , %formwiz..id $+ %pos
  inc %formwiz..id
}

alias -l obj.build.TabDlg.SSTab {
  var %x = %formwiz..offx + $obj($1).left, %y = %formwiz..offy + $obj($1).top, %xywh = $ccrd(%x).x $ccrd(%y).y $ccrd($obj($1).width).x $ccrd($obj($1).height).y
  var %i = 1, %t = $hmatch(dlg.load, $1 $+ .TabCaption(*), 0), %curtab = $obj($1).tab
  %formwiz..tabindex = -1
  dlgout ; $1
  if (%curtab = $null) { %curtab = 0 }
  while (%i <= %t) {
    $buildsstab(%i, $1, $left($gettok($hmatch(dlg.load, $1 $+ .TabCaption(*), %i), -1, 40), -1), %xywh, %curtab)
    inc %i
  }
  dec %formwiz..id
  dlgout
  %formwiz..offx = %x
  %formwiz..offy = %y
}
alias -l obj.endbuild.TabDlg.SSTab {
  dec %formwiz..offx $obj($1).left
  dec %formwiz..offy $obj($1).top
}
alias -l buildsstab {
  var %i = 0, %t = $obja($2, Tab, $3).controlcount, %pos, %obj
  if ($1 = 1) { %pos = , $4 }
  dlgout tab $dlgtxt($obja($2, TabCaption, $3)) $+ , %formwiz..id $+ %pos
  while (%i < %t) {
    %obj = $obja($2, Tab, $3, Control, %i)
    obj %obj <tab> %formwiz..id
    if ($3 != $5) { obj %obj left $calc($obj(%obj).left + 75000) }
    inc %i
  }
  inc %formwiz..id
}



alias -l dlg.test {
  var %w = @formwiz.tmp, %i = 1, %t = $line($1, 0), %fn = " $+ $scriptdir $+ formwiz.tmp.mrc"
  tokenize 32 $1 $window($1).title
  window -hl %w | filter -cww $1 %w *
  if ($fline(%w, dialog * $'{, 1)) {
    rline %w $ifmatch dialog _formwiz.test $'{
    iline %w $calc($ifmatch + 1) icon $scriptdir $+ formwiz.icl, 1
  }
  aline %w on *:DIALOG:_formwiz.test:sclick: $+ $3 $+ :.timer 1 0 .remove $!script $!chr(124) .unload -rs $!script
  write -c %fn | savebuf %w %fn
  window -c %w
  .timer -o 1 0 .reload -rs %fn $chr(124) $!dialog(_formwiz.test, _formwiz.test, -4)
}
alias -l dlg.copy var %w = @formwiz.dialog, %i = 1, %t = $line(%w, 0) | clipboard | while (%i <= %t) { clipboard -a $line(%w, %i) $+ $crlf | inc %i }
alias -l dlg.save {
  var %w = @formwiz.tmp, %wi = @formwiz.dialog, %i = 1, %t = $line(%wi, 0), %fn = " $+ $1- $+ "
  if ($isfile(%fn)) && (!$input(The file ' $+ $nopath(%fn) $+ ' already exists. $+ $crlf $+ Overwrite?, 136, Save dialog table)) { return }
  fwset savedir $nofile(%fn)
  window -hl %w
  filter -cww %wi %w *
  write -c %fn | savebuf %w %fn
  window -c %w
}
on *:DIALOG:_formwiz.test:init:0:dlg.center formwiz $dname | dialog -t $dname $dialog($dname).title [testing]


alias -l '{ return $chr(123)
alias -l out did -o formwiz 302 1 $3-
alias -l dlgout if ($1- != $null) && ((%formwiz..comments) || ($left($1, 1) != $chr(59))) { aline @formwiz.dialog $1- }
